Bug 1173949 - layout switching does not work
Summary: layout switching does not work
Keywords:
Status: CLOSED EOL
Alias: None
Product: Fedora
Classification: Fedora
Component: mutter
Version: 25
Hardware: Unspecified
OS: Unspecified
unspecified
high
Target Milestone: ---
Assignee: Florian Müllner
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2014-12-14 12:29 UTC by Stas Sergeev
Modified: 2017-12-12 10:12 UTC (History)
11 users (show)

Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2017-12-12 10:12:57 UTC


Attachments (Terms of Use)
screen shot (248.02 KB, image/png)
2014-12-20 11:11 UTC, Stas Sergeev
no flags Details
dconf/user (23.45 KB, application/x-gzip)
2014-12-20 15:35 UTC, Stas Sergeev
no flags Details

Description Stas Sergeev 2014-12-14 12:29:11 UTC
Description of problem:
I have configured 3 layouts: us, ru+legacy, table:rusle.
The switching shortcuts worka and make the indicator applet
to cycle the layouts.
But in fact, even when it shows 'en', it still types cyrillic.

Version-Release number of selected component (if applicable):
Not sure what component is to blame...
control-center-3.14.2-1.fc21.x86_64

How reproducible:
Easily.

Steps to Reproduce:
1. Set up 3 layouts specified above
2. Try cyclic switching
3. Try typing English

Actual results:
Types Cyrillic, no matter what

Expected results:
Types whatever is indicated on indicator.

Additional info:
$ gsettings list-recursively org.gnome.desktop.input-sources
org.gnome.desktop.input-sources show-all-sources true
org.gnome.desktop.input-sources per-window true
org.gnome.desktop.input-sources current uint32 1
org.gnome.desktop.input-sources sources [('xkb', 'us'), ('xkb', 'ru+legacy'), ('ibus', 'table:rusle')]
org.gnome.desktop.input-sources xkb-options ['grp:rctrl_rshift_toggle', 'terminate:ctrl_alt_bksp']

The problem is very annoying.
The only work-around I've found is to switch to text
console and do
DISPLAY=:0 setxkbmap us

Comment 1 Rui Matos 2014-12-15 16:36:09 UTC
Does it always happen? Or only after a while? If it only happens after a while past log in, is there any specific event that makes it stop working?

Any messages in your logs? Please check journalctl.

Comment 2 Stas Sergeev 2014-12-15 16:46:33 UTC
Yes, it happens always.
journalctl | tail
takes about 20sec to print something...
But cycling through layout and typing doesn't
add anything to it.

Note: I use cinnamon
Note: I upgraded with yum.

Comment 3 Stas Sergeev 2014-12-15 17:39:08 UTC
But I really dont think its a control-center bug.
The layouts were configured properly, the configs
were listed in my initial comment, they are fine!

What component is at fault? I don't think it is
either gnome-cc or cinnamon. Please suggest me a
better component to assign this to.

Comment 4 Rui Matos 2014-12-15 18:01:25 UTC
I don't really know more about cinnamon than that it was forked from gnome at some point. I'd say it's either in cinnamon-settings-daemon or in the mutter fork

Comment 5 leigh scott 2014-12-15 18:18:49 UTC
(In reply to Stas Sergeev from comment #0)

> Additional info:
> $ gsettings list-recursively org.gnome.desktop.input-sources
> org.gnome.desktop.input-sources show-all-sources true
> org.gnome.desktop.input-sources per-window true
> org.gnome.desktop.input-sources current uint32 1
> org.gnome.desktop.input-sources sources [('xkb', 'us'), ('xkb',
> 'ru+legacy'), ('ibus', 'table:rusle')]
> org.gnome.desktop.input-sources xkb-options ['grp:rctrl_rshift_toggle',
> 'terminate:ctrl_alt_bksp']


post

gsettings list-recursively org.cinnamon.desktop.input-sources

Comment 6 Stas Sergeev 2014-12-15 18:25:32 UTC
Here you are:
---
$ gsettings list-recursively org.cinnamon.desktop.input-sources
org.cinnamon.desktop.input-sources show-all-sources false
org.cinnamon.desktop.input-sources current uint32 0
org.cinnamon.desktop.input-sources sources [('xkb', 'us'), ('xkb', 'ru+legacy'), ('ibus', 'rusle')]
org.cinnamon.desktop.input-sources xkb-options ['terminate:ctrl_alt_bksp']
---

Hmm, slightly differs from org.gnome.desktop.input-sources.

Comment 7 Stas Sergeev 2014-12-15 19:50:50 UTC
How can I switch between cinnamon and
gnome-shell without using gdm? I need to
switch and test things without cinnamon.
google says I can do that with gdm, but
I am using 'startx' instead.

Comment 8 Mike FABIAN 2014-12-17 15:20:14 UTC
I tried to reproduce this. It seems quite broken under cinnamon.
But for me it is broken in different ways than for Stas.

I did the following:

- Installed Fedora-Live-Workstation-x86_64-21-5.iso
  (That is the final release). Used Japanese during the install,
  added the US English keyboard layout.

- Installed the other desktops:
  sudo yum groupinstall kde-desktop-environment xfce-desktop-environment lxde-desktop-environment cinnamon-desktop-environment mate-desktop-environment sugar-desktop-environment developer-workstation-environment c-development development-tools

- log out of gnome

- log into cinnamon

- Now in cinnamon, the settings look like:

    [mfabian@localhost ~]$ gsettings list-recursively org.gnome.desktop.input-sources
    org.gnome.desktop.input-sources show-all-sources false
    org.gnome.desktop.input-sources per-window false
    org.gnome.desktop.input-sources current uint32 0
    org.gnome.desktop.input-sources sources [('ibus', 'kkc'), ('xkb', 'us'), ('xkb', 'jp')]
    org.gnome.desktop.input-sources xkb-options @as []
    [mfabian@localhost ~]$ gsettings list-recursively org.cinnamon.desktop.input-sources
    org.cinnamon.desktop.input-sources show-all-sources false
    org.cinnamon.desktop.input-sources current uint32 0
    org.cinnamon.desktop.input-sources sources @a(ss) []
    org.cinnamon.desktop.input-sources xkb-options @as []
    [mfabian@localhost ~]$

- ibus-ui-gtk3 is running.

  Should this be running???

- I can see the ibus input methods in the panel and can switch them with the mouse

  But this does not seem to be a cinnamon thing (i.e. ibus seems not
  integrated into cinnamon like it is into gnome). It is the standard
  ibus panel widget, just as it is shown for example in KDE.

  Does cinnamon have any ibus integration???

- I cannot switch the input methods using the default shortcut
  Super+Space, but Super+Space+Space (keep holding the Super key
  and press Space twice) inserts a space *and* switches the input method.

- I cannot find any input method setup in the cinnamon setup (Probably
  there isn’t because ibus is probably not integrated in cinnamon).
  Right mouse  click on the ibus widget in the panel pops up  a menu
  which has a "setup" where I can open the standard ibus setup tool.

- I can change the hotkey to "Shift+Space" in the ibus setup, after
  doing that, changing the input methods with "Shift+Space" works
  without problems.

Comment 9 Stas Sergeev 2014-12-17 15:55:07 UTC
>  Does cinnamon have any ibus integration???
But I have problems even with xkb layouts this time.
I have not yet started to test ibus.

Is there any simple way to switch back to gnome-shell
to make sure it is indeed cinnamon-specific?

Comment 10 leigh scott 2014-12-17 16:13:44 UTC
(In reply to Mike FABIAN from comment #8)

>   Does cinnamon have any ibus integration???

No much, most is in mintlocale-1.2.x (fedora has 1.1.6) and isn't compatible with fedora.
I have no plans to address this issue myself as I don't use or need ibus.

Comment 11 Mike FABIAN 2014-12-17 21:32:27 UTC
(In reply to Stas Sergeev from comment #9)
> >  Does cinnamon have any ibus integration???
> But I have problems even with xkb layouts this time.
> I have not yet started to test ibus.
> 
> Is there any simple way to switch back to gnome-shell
> to make sure it is indeed cinnamon-specific?

I am sure that this is cinnamon specific.

Comment 12 Stas Sergeev 2014-12-17 21:50:03 UTC
Could you please confirm that you mean
exactly my xkb problem?
I find it a bit strange that an xkb problem
is cinnamon specific, and also I think you
haven't reproduced exactly that. So maybe its
still nice to double-check.
Please, is there really no way to switch
back to gnome-shell? Oh c'mon! :)

Comment 13 Mike FABIAN 2014-12-18 13:38:26 UTC
(In reply to Stas Sergeev from comment #12)
> Please, is there really no way to switch
> back to gnome-shell? Oh c'mon! :)

I would recommend using gdm, then you can easily switch
between all desktops.

As I wrote in comment#8, I  installed all desktops
with

    sudo yum groupinstall  cinnamon-desktop-environment ...

and then use gdm to switch between them. Looking into /bin/startx
and the other scripts it sources, it seems to be more
complicated to switch desktops with startx.

Comment 14 Stas Sergeev 2014-12-19 23:47:50 UTC
OK, I am really a moron...
After activating gdm I've found that
this is not cinnamon! Just a couple of
themes (Application menu, Alternatetab etc)
that make gnome-shell look a bit like cinnamon.
Moreover, in cinnamon I don't have such a
problem. Sorry for that confusion.
Reassigning to something gnome-specific...

Comment 15 Mike FABIAN 2014-12-20 11:04:55 UTC
(In reply to Stas Sergeev from comment #14)
> OK, I am really a moron...
> After activating gdm I've found that
> this is not cinnamon!

OK (cinnamon is quite broken when using it with ibus, but
that is another problem then, you have a problem with gnome).

> Just a couple of themes (Application menu, Alternatetab etc) that
> make gnome-shell look a bit like cinnamon.  Moreover, in cinnamon I
> don't have such a problem. Sorry for that confusion.  Reassigning to
> something gnome-specific...

gdm offers 3 variants of gnome:

   - GNOME
   - GNOME classic
   - GNOME on Wayland

Which one are you using? Maybe “Gnome classic” because you say it looks a bit
like cinnamon?

Maybe attach a screenshot as well to show how your desktop looks like.

I have tried with “GNOME classic” and “GNOME” now and cannot reproduce your
problem. Same input sources as you mentioned in comment#0,
Switching works without problems, both with the mouse and the Super+Space
keyboard shortcut. I can type English with the US layout and Russian
with the Russian legacy layout and with the “rusle” Table of ibus-table.

(Side note: why is ibus-table-1.8.9 in Fedora 21 and not the newer ibus-table-1.9.1? That has nothing to do with your problem though).

Comment 16 Stas Sergeev 2014-12-20 11:11:56 UTC
Created attachment 971427 [details]
screen shot

OK, since I am a complete nitwit in this
gnomish stuff, here's the screen-shot from
which you can decide what desktop is this. :)

Comment 17 leigh scott 2014-12-20 12:02:17 UTC
(In reply to Stas Sergeev from comment #16)
> Created attachment 971427 [details]

> which you can decide what desktop is this. :)


It's gnome-shell

Comment 18 Mike FABIAN 2014-12-20 14:39:36 UTC
Yes, that’s the standard GNOME (not the classic which would be gray instead
of black and have a taskbar thing at the bottom).

I cannot reproduce your input problem at all with GNOME on Fedora 21,
it works fine for me.

Comment 19 Stas Sergeev 2014-12-20 15:35:51 UTC
Created attachment 971486 [details]
dconf/user

Could you please try with this ~/.config/dconf/user?

Comment 20 Stas Sergeev 2014-12-20 15:51:14 UTC
Don't forget to chown the file the file or
it won't be picked up (yes, it is obvious for you,
but I want to avoid any possible confusion, any
possible mistake).

Comment 21 Mike FABIAN 2014-12-21 00:43:15 UTC
Works for me even with your ~/.config/dconf/user.

Comment 22 Stas Sergeev 2014-12-21 09:18:51 UTC
OK, it appears it depends on a way you
cycle through the layouts.
Please use Right Ctrl-Shift to cycle. Assuming
you have my dconf settings, you have that
combo configured to cycle layouts.
For example if I use mouse to change layouts,
it works better.

So:
1. open gnome-terminal
2. type something, its latinic
3. Right Ctrl-Shift
4. Type something, its cyrillic
5. Right Ctrl-Shift
6. Type something, still cyrillic (ibus:rusle)
7. Right Ctrl-Shitf
8. Type something, still cyrillic (a bug)

Comment 23 Mike FABIAN 2014-12-21 09:32:54 UTC
I didn’t get this after adding your ~/.config/dconf/user file, but
after I configured switching to the next input method with
the modifier only key compination RightControl+RightShift, I can
reproduce it.

[mfabian@localhost ~]$ dconf dump /org/gnome/desktop/input-sources/
[/]
current=uint32 0
sources=[('xkb', 'us'), ('xkb', 'ru+legacy'), ('ibus', 'table:rusle')]
xkb-options=['grp:rctrl_rshift_toggle']
[mfabian@localhost ~]$ 

After switching with RightControl+RightShift it gets into that broken state
where one can type only Cyrillic even though 'en' is displayed in the
Gnome panel. 

Switching with the standard key combination Super+Space
(left Windows+Space) or with the mouse does not cause this problem.

Comment 24 Stas Sergeev 2014-12-21 09:51:17 UTC
Thanks! :)

Comment 25 Mike FABIAN 2014-12-21 14:30:32 UTC
I was trying to reproduce this with another set of input methods,
like this:

[mfabian@localhost ~]$ dconf dump /org/gnome/desktop/input-sources/
[/]
current=uint32 0
sources=[('ibus', 'kkc'), ('xkb', 'us'), ('xkb', 'jp')]
xkb-options=['grp:rctrl_rshift_toggle']
[mfabian@localhost ~]$ 

I.e. Japanese keyboard, US keyboard and the Japanese input methods "kkc"
(Kanji-Kana). But with these 3 input sources I *cannot*
reproduce the problem when switching the input sources with
RightControl+RightShift.

Comment 26 Mike FABIAN 2014-12-21 14:33:43 UTC
By the way, I noticed that 

[mfabian@localhost ~]$ dconf dump /org/gnome/desktop/input-sources/
[/]
current=uint32 0   <--- this is always 0!
...

I.e. the “current” key is always 0 in Fedora 21.

In Fedora 20, it contained an integer number showing
the currently active input source, i.e. it was 0 when the topmost
input source (as displayed in the panel menu) was active, 1 when the
second input source from the top was active, etc...
But on Fedora 21, it is always 0, even when the switching
of the input sources seems to work fine.

Is that intentional??

Comment 27 Fedora End Of Life 2015-11-04 10:52:25 UTC
This message is a reminder that Fedora 21 is nearing its end of life.
Approximately 4 (four) weeks from now Fedora will stop maintaining
and issuing updates for Fedora 21. It is Fedora's policy to close all
bug reports from releases that are no longer maintained. At that time
this bug will be closed as EOL if it remains open with a Fedora  'version'
of '21'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version.

Thank you for reporting this issue and we are sorry that we were not 
able to fix it before Fedora 21 is end of life. If you would still like 
to see this bug fixed and are able to reproduce it against a later version 
of Fedora, you are encouraged  change the 'version' to a later Fedora 
version prior this bug is closed as described in the policy above.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events. Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.

Comment 28 Stas Sergeev 2015-11-04 13:18:17 UTC
Any progress with this one?

Comment 29 Fedora End Of Life 2016-07-19 19:04:22 UTC
Fedora 22 changed to end-of-life (EOL) status on 2016-07-19. Fedora 22 is
no longer maintained, which means that it will not receive any further
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of
Fedora please feel free to reopen this bug against that version. If you
are unable to reopen this bug, please file a new report against the
current release. If you experience problems, please add a comment to this
bug.

Thank you for reporting this bug and we are sorry it could not be fixed.

Comment 30 Bastien Nocera 2016-10-06 12:32:23 UTC
(In reply to Stas Sergeev from comment #28)
> Any progress with this one?

Nobody can reproduce your problem, sorry.

I also couldn't find a description of how you switched layouts (under X11, this is either handled by X11, and mutter/gnome-shell is notified, or in gnome-shell which handles the combo directly).

(In reply to Mike FABIAN from comment #26)
> By the way, I noticed that 
> 
> [mfabian@localhost ~]$ dconf dump /org/gnome/desktop/input-sources/
> [/]
> current=uint32 0   <--- this is always 0!
> ...
> 
> I.e. the “current” key is always 0 in Fedora 21.
<snip>
> Is that intentional??

The description says: "DEPRECATED: This key is deprecated and ignored."

Comment 31 Stas Sergeev 2016-10-06 19:21:46 UTC
(In reply to Bastien Nocera from comment #30)
> (In reply to Stas Sergeev from comment #28)
> > Any progress with this one?
> Nobody can reproduce your problem, sorry.
But comment #23 clearly says Mike have reproduced it.
That's why I wonder. The bug is quite annoying and
very long-standing already.

> I also couldn't find a description of how you switched layouts (under X11,
> this is either handled by X11, and mutter/gnome-shell is notified, or in
> gnome-shell which handles the combo directly).
I used standard keyboard configuration applet of gnome.

Comment 32 Fedora End Of Life 2017-07-25 18:45:39 UTC
This message is a reminder that Fedora 24 is nearing its end of life.
Approximately 2 (two) weeks from now Fedora will stop maintaining
and issuing updates for Fedora 24. It is Fedora's policy to close all
bug reports from releases that are no longer maintained. At that time
this bug will be closed as EOL if it remains open with a Fedora  'version'
of '24'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version'
to a later Fedora version.

Thank you for reporting this issue and we are sorry that we were not
able to fix it before Fedora 24 is end of life. If you would still like
to see this bug fixed and are able to reproduce it against a later version
of Fedora, you are encouraged  change the 'version' to a later Fedora
version prior this bug is closed as described in the policy above.

Although we aim to fix as many bugs as possible during every release's
lifetime, sometimes those efforts are overtaken by events. Often a
more recent Fedora release includes newer upstream software that fixes
bugs or makes them obsolete.

Comment 33 Fedora End Of Life 2017-11-16 19:35:54 UTC
This message is a reminder that Fedora 25 is nearing its end of life.
Approximately 4 (four) weeks from now Fedora will stop maintaining
and issuing updates for Fedora 25. It is Fedora's policy to close all
bug reports from releases that are no longer maintained. At that time
this bug will be closed as EOL if it remains open with a Fedora  'version'
of '25'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version'
to a later Fedora version.

Thank you for reporting this issue and we are sorry that we were not
able to fix it before Fedora 25 is end of life. If you would still like
to see this bug fixed and are able to reproduce it against a later version
of Fedora, you are encouraged  change the 'version' to a later Fedora
version prior this bug is closed as described in the policy above.

Although we aim to fix as many bugs as possible during every release's
lifetime, sometimes those efforts are overtaken by events. Often a
more recent Fedora release includes newer upstream software that fixes
bugs or makes them obsolete.

Comment 34 Fedora End Of Life 2017-12-12 10:12:57 UTC
Fedora 25 changed to end-of-life (EOL) status on 2017-12-12. Fedora 25 is
no longer maintained, which means that it will not receive any further
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of
Fedora please feel free to reopen this bug against that version. If you
are unable to reopen this bug, please file a new report against the
current release. If you experience problems, please add a comment to this
bug.

Thank you for reporting this bug and we are sorry it could not be fixed.


Note You need to log in before you can comment on or make changes to this bug.